%test che calcola e traccia un grafico di:
%peso del MST, frequenza dei nodi di grado 1,2,3 e >3 medi, e grado massimo  su r istanze
%per grafi euclidei in Rn generati in modo aleatorio 
%e con numero di nodi uguale a 100*1, 100*2, 100*3, ..., 10000
%e confronta i risultati nel caso monopartito e bipartito

%numero massimo di nodi (x100)
n=100;

%numero di test per ogni numero di nodi
r=5;

%dimensione dello spazio in cui sono contenuti i nodi
m=3;

peso_gen=zeros(n,1);
deg1_gen=zeros(n,1);
deg2_gen=zeros(n,1);
deg3_gen=zeros(n,1);
deg4_gen=zeros(n,1);
deg5_gen=zeros(n,1);
deg6_gen=zeros(n,1);
totdeg_gen=zeros(n,1);
maxdeg_gen=zeros(n,1);

peso_genbi=zeros(n,1);
deg1_genbi=zeros(n,1);
deg2_genbi=zeros(n,1);
deg3_genbi=zeros(n,1);
deg4_genbi=zeros(n,1);
deg5_genbi=zeros(n,1);
deg6_genbi=zeros(n,1);
totdeg_genbi=zeros(n,1);
maxdeg_genbi=zeros(n,1);

for k=n:-1:1
    
peso=zeros(r,1);
deg1=zeros(r,1);
deg2=zeros(r,1);
deg3=zeros(r,1);
deg4=zeros(r,1);
deg5=zeros(r,1);
deg6=zeros(r,1);
totdeg=zeros(r,1);
maxdeg=zeros(r,1);

pesobi=zeros(r,1);
deg1bi=zeros(r,1);
deg2bi=zeros(r,1);
deg3bi=zeros(r,1);
deg4bi=zeros(r,1);
deg5bi=zeros(r,1);
deg6bi=zeros(r,1);
totdegbi=zeros(r,1);
maxdegbi=zeros(r,1);

part=zeros(100*k,1);
part(1:2:end)=1;


for s=1:r
v=random('Uniform', 0, 1,[100*k,m]);
T=MSTJ(v);
T_deg=degree(T);
T_w=sum(T.Edges.Weight);

peso(s)=T_w;
deg1(s)=mean((T_deg==1));
deg2(s)=mean((T_deg==2));
deg3(s)=mean((T_deg==3));
deg4(s)=mean((T_deg==4));
deg5(s)=mean((T_deg==5));
deg6(s)=mean((T_deg>=6));
totdeg(s)=mean(T_deg);
maxdeg(s)=max(T_deg);


v=random('Uniform', 0, 1,[100*k,m]);
T=MSTJbi(v,part);
T_deg=degree(T);
T_w=sum(T.Edges.Weight);

pesobi(s)=T_w;
deg1bi(s)=mean((T_deg==1));
deg2bi(s)=mean((T_deg==2));
deg3bi(s)=mean((T_deg==3));
deg4bi(s)=mean((T_deg==4));
deg5bi(s)=mean((T_deg==5));
deg6bi(s)=mean((T_deg>=6));
totdegbi(s)=mean(T_deg);
maxdegbi(s)=max(T_deg);


end
peso_gen(k)=mean(peso);
deg1_gen(k)=mean(deg1);
deg2_gen(k)=mean(deg2);
deg3_gen(k)=mean(deg3);
deg4_gen(k)=mean(deg4);
deg5_gen(k)=mean(deg5);
deg6_gen(k)=mean(deg6);
totdeg_gen(k)=mean(totdeg);
maxdeg_gen(k)=mean(maxdeg);

peso_genbi(k)=mean(pesobi);
deg1_genbi(k)=mean(deg1bi);
deg2_genbi(k)=mean(deg2bi);
deg3_genbi(k)=mean(deg3bi);
deg4_genbi(k)=mean(deg4bi);
deg5_genbi(k)=mean(deg5bi);
deg6_genbi(k)=mean(deg6bi);
totdeg_genbi(k)=mean(totdegbi);
maxdeg_genbi(k)=mean(maxdegbi);
end

t=1:n;
t=100*t;

figure (1)
plot(t,peso_gen)
hold on
plot(t,peso_genbi)
legend('monopartito','bipartito'   , 'Location', 'best')
xlabel('numero nodi')
ylabel('peso del MST')
hold off

figure (2)
plot(t,deg1_gen)
hold on
plot(t,deg1_genbi)
ylim([0,1])
legend( 'monopartito','bipartito'  , 'Location', 'best')
xlabel('numero nodi ')
ylabel('frequenza dei nodi di grado 1')
hold off

figure (3)
plot(t,deg2_gen)
hold on
plot(t,deg2_genbi)
ylim([0,1])
legend('monopartito','bipartito'  , 'Location', 'best')
xlabel('numero nodi ')
ylabel('frequenza dei nodi di grado 2')
hold off

figure (4)
plot(t,deg3_gen)
hold on
plot(t,deg3_genbi)
ylim([0,1])
legend('monopartito','bipartito' , 'Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado 3' )
hold off

figure (5)
plot(t,deg4_gen)
hold on
plot(t,deg4_genbi)
ylim([0,1])
legend('monopartito','bipartito' , 'Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado 4' )
hold off

figure (6)
plot(t,deg5_gen)
hold on
plot(t,deg5_genbi)

legend('monopartito','bipartito' , 'Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado 5' )
hold off

figure (7)
plot(t,deg6_gen)
hold on
plot(t,deg6_genbi)

legend('monopartito','bipartito' , 'Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado maggiore di 5' )
hold off

figure (8)
plot(t,totdeg_gen)
hold on
plot(t,totdeg_genbi)
legend('monopartito','bipartito' , 'Location', 'best')
xlabel('numero nodi')
ylabel('grado medio' )
hold off

figure (9)
plot(t,maxdeg_gen)
hold on
plot(t,maxdeg_genbi)
legend('monopartito','bipartito' , 'Location', 'best')
xlabel('numero nodi')
ylabel('grado max' )
hold off
